---------------------------------------------------------------------------
-- ProLevels - light weight professions notifier
-- Version 1.0 28-01-2016
-- Version 1.4 25-08-2016
-- Version 1.5 30-08-2016 Added gui options and Legion currencies
-- Version 1.6 30-08-2016 Increased max skill level to 800
-- Version 1.7 14-09-2016 Auto detect cap's added
-- Author : RealID ReverendDave#2976
---------------------------------------------------------------------------

PL_Settings = {
	MiniMapX = 0,
	MiniMapY = 0,
	Enabled = true,
	Nagging = true,
	capText = nil,
	capAmnt = nil,
	wrnAmnt = nil
}


-- presets
local ProLevels_MAX = 800
local ProLevels_MAXCoin = 10000000000
local ProLevels_CapText = { "Valor","Honor Points","Garrison Resources","Nethershard","Ancient Mana","Curious Coin","Order Resources","Seal of Broken Fate","Shadowy Coins","Sightless Eye","Timeworn Artifact" }
local ProLevels_CapAmnt = { 5000,4000,10000,2000,300,99999,99999,10,500,5000,1000}
local ProLevels_WrnAmnt = { 4500,3600,9500,1900,250,99999,99999,8,400,4500,980}
-- variables
local ProLevels_CurAmnt = { }
local ProLevels_PreAmnt = { }
local shownit = 0 ;
local ProLevelsPopUp = nil
local PL_Dragx = 0
local PL_Dragy = 0

local PL_Edit = {
	currency = 0,
	cap,
	wrn
}
						     
local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("ProLevels : " .. tostring(msg))
end

function ProLevels_OnEvent(self,event,...)

	if (event == "CHAT_MSG_SKILL") then
		ProLevel_DoProfessions()
	elseif (event == "PLAYER_MONEY" or event == "CURRENCY_DISPLAY_UPDATE") then
		ProLevel_CheckCurrencies()
	elseif (event == "VARIABLES_LOADED") then
		print("Version 1.6 ")
			
		if (PL_Settings.capText == nil) then
			PL_Settings.capText = ProLevels_CapText
		end
		if (PL_Settings.capAmnt == nil) then
			PL_Settings.capAmnt = ProLevels_CapAmnt
		end
		if (PL_Settings.wrnAmnt == nil) then
			PL_Settings.wrnAmnt = ProLevels_WrnAmnt
		end
			
		ProLevel_DoProfessions()
		ProLevel_CheckCurrencies()
		
		local j = #PL_Settings.capText
		local i = 1
		
		while(i <= j) do
			ProLevels_CurAmnt[i] = 0
			ProLevels_PreAmnt[i] = 0
			i = i + 1
		end

	end
end

function ProLevel_DoProfessions()
local p1,p2,arch,fish,cook,aid = GetProfessions()
		
	if not (p1 == nil) then
		ProLevel_CheckProfession(p1)
	end
	if not (p2 == nil) then
		ProLevel_CheckProfession(p2)
	end
	if not (arch == nil) then
		ProLevel_CheckProfession(arch)
	end
	if not (fish == nil) then
		ProLevel_CheckProfession(fish)
	end
	if not (cook == nil) then
		ProLevel_CheckProfession(cook)
	end
	if not (aid == nil) then
		ProLevel_CheckProfession(aid)
	end
end

function ProLevel_CheckProfession(index)

	if (PL_Settings.Enabled == false) then return end

local name,_,lvl,max = GetProfessionInfo(index)
			
	if ((lvl >= (max - 5)) and max < ProLevels_MAX) then
		print("|cffFF0000WARNING: " .. name .. " at " .. lvl .. " of " .. max)
	end
end

function ProLevel_CheckCurrencies()

	if (PL_Settings.Enabled == false) then return end

	if (GetMoney() > (ProLevels_MAXCoin - 50000000)) then
		print("|cffFF0000WARNING: GOLD at " .. GetMoney() .. ", near limit")
	end
	
	local listSize = GetCurrencyListSize();
	local n = 1
	local name,count
	local j, id, totalMax
	
	while(n <= listSize) do
		name,_,_,_,_,count,_,totalMax = GetCurrencyListInfo(n)
		if (totalMax == nil) then totalMax = 0 end
		j = 1
		while(j <= (#PL_Settings.capText)) do
			if ((PL_Settings.capText[j] == name) ) then
				if (PL_Settings.capAmnt[j]) then
					if (totalMax > PL_Settings.capAmnt[j]) then
						local dx = totalMax - PL_Settings.capAmnt[j]
						PL_Settings.capAmnt[j] = totalMax
						print(name .. " cap amount raised to " .. totalMax .. " from " .. (totalMax - dx))
						if (PL_Settings.wrnAmnt[j] + dx) <= totalMax then
							PL_Settings.wrnAmnt[j] = PL_Settings.wrnAmnt[j] + dx
						end
						
					end
				
					if (ProLevels_CurAmnt[j] == 0) then
						ProLevels_CurAmnt[j] = count
					end
					if ((count >= PL_Settings.wrnAmnt[j]) and (count > ProLevels_PreAmnt[j] or PL_Settings.Nagging == true)) then
						ProLevels_PreAmnt[j] = count
						print("|cffFF0000WARNING: "..name.." at " .. count .. ", limit is " .. PL_Settings.capAmnt[j])
					end
				end
				break
			end
			j = j + 1
		end
		n = n + 1
	end
end

function ProLevels_handleCmd(msg, editbox)

	ProLevel_DoProfessions()
	ProLevel_CheckCurrencies()
	
	local listSize = GetCurrencyListSize();
	local n = 1
	local name,count,totalMax
	
	while(n <= listSize) do
		name,_,_,_,_,count,_,totalMax = GetCurrencyListInfo(n)
		if (totalMax == nil) then totalMax = "unrestricted" end
			
		print("Available : " .. name .. " you have " .. count .. ", limit is " .. totalMax)
		n = n + 1
	end

end

function ProLevels_OnLoad(me)
	SLASH_PROLEVELS1 = "/prolevels"
	SLASH_PROLEVELS2 = "/pl"
	SlashCmdList["PROLEVELS"] = ProLevels_handleCmd
	me:RegisterEvent("PLAYER_ENTERING_WORLD")
	me:RegisterEvent("CHAT_MSG_SKILL")
	me:RegisterEvent("PLAYER_MONEY")
	me:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	me:RegisterEvent("VARIABLES_LOADED")
	
	StaticPopupDialogs["ProLevelsEditing"] = {
	text = "Edit the %s of %s",
	button1 = "Accept",
	button2 = "Cancel",
	OnAccept = function(self, data, data2) onNewEditedText(data) end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
	hasEditBox = true,
}

end

function PL_MinimapButton_DraggingFrame_Start()
	PL_Dragx,PL_Dragy = GetCursorPosition()
	PL_Dragx = PL_Dragx - PL_Settings.MiniMapX
	PL_Dragy = PL_Dragy - PL_Settings.MiniMapY
end

function PL_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()

	xpos = (xpos - PL_Dragx)
	ypos = (ypos - PL_Dragy)
	
	PL_Settings.MiniMapX = xpos
	PL_Settings.MiniMapY = ypos

	PL_Set_MiniMap()
end

function PL_Set_MiniMap()
	local left, bottom, width, height = Minimap:GetRect()

	height = height + 32 -- allows us to place it below the map
	
	if (PL_Settings.MiniMapX < 0) then PL_Settings.MiniMapX = 0 
	elseif (PL_Settings.MiniMapX > width) then PL_Settings.MiniMapX = width end
	if (PL_Settings.MiniMapY > 0) then PL_Settings.MiniMapY = 0 
	elseif (PL_Settings.MiniMapY < (0-height)) then PL_Settings.MiniMapY = (0-height) end

	PL_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",PL_Settings.MiniMapX,PL_Settings.MiniMapY)
end

function PL_MinimapButton_OnClick()
	local button =  GetMouseButtonClicked() 

	if (button == "LeftButton") then
	else
		 InterfaceOptionsFrame_OpenToCategory(PL_ProLevelsConfigFrame);
		 InterfaceOptionsFrame_OpenToCategory(PL_ProLevelsConfigFrame);
	end
end

function PL_MinimapButton_OnEnter(self)
	local txt = "|cFFff8844ProLevels\r\n|cFF884444Right click for options"
	
	GameTooltip:SetOwner(self or UIParent, "ANCHOR_LEFT")
	GameTooltip:SetText( txt )
	GameTooltip:Show()
end

function PL_MinimapButton_OnLeave(self)
  GameTooltip:Hide()
end

function PL_MinimapButton_OnLoad(self)
	self:RegisterForClicks("LeftButtonUp","RightButtonUp")
	self:RegisterForDrag("LeftButton","RightButton")
end

function PL_ProLevels_toggleEnable()
	if (PL_Settings.Enabled == true) then
		PL_Settings.Enabled = false
	else
		PL_Settings.Enabled = true
	end
end

function PL_ProLevels_toggleNag()
	if (PL_Settings.Nagging == true) then
		PL_Settings.Nagging = false
	else
		PL_Settings.Nagging = true
	end
end

function PL_ProLevels_ConfigOnLoad(panel)

	panel.name = "ProLevels Management" ;
    InterfaceOptions_AddCategory(panel);
end

function PL_ProLevels_ConfigOnShow()
	PL_CheckButtonOn:SetChecked(PL_Settings.Enabled == true)
	PL_CheckButtonNag:SetChecked(PL_Settings.Nagging == true)
	PL_ScrollBar:Show()
end

function PL_ScrollBar_Update()
	
	local line; -- 1 through 5 of our window to scroll
   local lineplusoffset; -- an index into our data calculated from the scroll offset
   FauxScrollFrame_Update(PL_ScrollBar,50,5,16);
   for line=1,5 do
     lineplusoffset = line + FauxScrollFrame_GetOffset(PL_ScrollBar)
     if lineplusoffset < 50 and PL_Settings.capText[lineplusoffset] ~= nil then
       getglobal("PL_Entry"..line):SetText(PL_Settings.capText[lineplusoffset])
	   getglobal("PL_Entry1"..line):SetText("Cap " .. PL_Settings.capAmnt[lineplusoffset])
	   getglobal("PL_Entry2"..line):SetText("Alert " .. PL_Settings.wrnAmnt[lineplusoffset])
	   getglobal("PL_Entry3"..line):SetText("Currently " .. ProLevels_CurAmnt[lineplusoffset])
       getglobal("PL_Entry"..line):Show()
       getglobal("PL_Entry1"..line):Show()
       getglobal("PL_Entry2"..line):Show()
       getglobal("PL_Entry3"..line):Show()
     else
       getglobal("PL_Entry"..line):Hide()
       getglobal("PL_Entry1"..line):Hide()
       getglobal("PL_Entry2"..line):Hide()
       getglobal("PL_Entry3"..line):Hide()
     end
   end
end

function PL_EditButton_OnClicked(button)

	local key = tonumber(strtrim(button:GetName(),"PL_Entry"))
	local attrib,currency,val,ix

	if (key >= 31) then
		return
	end

	PL_Edit.currency = floor(key % 10) + FauxScrollFrame_GetOffset(PL_ScrollBar)
	currency = PL_Settings.capText[PL_Edit.currency]
	key = floor(key / 10)
	if (key == 0) then
		attrib = "Currency Name"
		val = currency
		PL_Edit.wrn = nil
		PL_Edit.cap = nil
	elseif (key == 1) then 
		attrib = "Cap"
		val = PL_Settings.capAmnt[PL_Edit.currency]
		PL_Edit.cap = PL_Edit.currency
		PL_Edit.wrn = nil
	elseif (key == 2) then 
		attrib = "Alert"
		val = PL_Settings.wrnAmnt[PL_Edit.currency]
		PL_Edit.wrn = PL_Edit.currency
		PL_Edit.cap = nil
	else return
	end
	
	ProLevelsPopUp = StaticPopup_Show ("ProLevelsEditing",attrib,currency)
	ProLevelsPopUp.editBox:SetText(val)
end

function onNewEditedText()
	txt = ProLevelsPopUp.editBox:GetText()
	val = tonumber(txt)
	
	if (PL_Edit.cap ~= nil) then
		if (val ~= nil) then
			PL_Settings.capAmnt[PL_Edit.cap]=val
		else
			print("Cap level must be at zero or above")
		end
	elseif (PL_Edit.wrn ~= nil) then
		if (val >= 0 and val <= PL_Settings.capAmnt[PL_Edit.wrn]) then
			PL_Settings.wrnAmnt[PL_Edit.wrn]=val
		else
			print("Alert level must be between zero and cap")
		end
	elseif (val == nil) then
		if (strlen(txt) > 1) then
			PL_Settings.capText[PL_Edit.currency] = txt
		else
			local i = PL_Edit.currency
			local j = #PL_Settings.capText
			
			while(i < (j-1)) do
				PL_Settings.capText[i] = PL_Settings.capText[i+1]
				PL_Settings.wrnAmnt[i] = PL_Settings.wrnAmnt[i+1]
				PL_Settings.capAmnt[i] = PL_Settings.capAmnt[i+1]
				ProLevels_PreAmnt[i] = ProLevels_PreAmnt[i+1]
				ProLevels_CurAmnt[i] = ProLevels_CurAmnt[i+1]
				i = i + 1
			end
			PL_Settings.capText[j] = nil
			PL_Settings.wrnAmnt[j] = nil
			PL_Settings.capAmnt[j] = nil
			ProLevels_PreAmnt[j] = nil
			ProLevels_CurAmnt[j] = nil
		end
	end
	
	PL_ScrollBar_Update()
end

function PL_ProLevels_addMonitor()

	local j = #PL_Settings.capText+1
	
	if (j < 50) then
		PL_Edit.currency = j
		PL_Edit.wrn = nil
		PL_Edit.cap = nil
		PL_Settings.wrnAmnt[j] = 0
		PL_Settings.capAmnt[j] = 0			
		ProLevels_PreAmnt[j] = 0			
		ProLevels_CurAmnt[j] = 0			
		ProLevelsPopUp = StaticPopup_Show ("ProLevelsEditing","Name"," a new value to monitor")
		return
	end
	
	print("Sorry, you have used all the available slots for this version :(")
	

end
